$ORIGIN {{ item }}.
$TTL {{ dns_ttl }}

; The Start Of Authority sets information for replication.  Every node
; is going to be its own authority, so the information for replication is
; mostly unneeded, unless we start delegating to other providers.  In this
; case the delegation should be to one of the nodes.  For instance, to
; delegate zones to dns.he.net, we'd add a delegation to athshe, and then
; to delegate to freedns.afraid.org, we'd add a delegation to
; anarres.sutty.nl.  The expire information is kept intentionally low
; because our strategy is for each node to provide their own IP addresses
; in the A* records, so when they're down, the information goes away with
; them.  If we had a typical, hierarchical setup, we'd want them high so
; if the authoritative server is down, the delegates keep serving the
; information.
{{ item }}. IN SOA {{ inventory_hostname }}. {{ inventory_hostname }}. ( {{ ansible_managed }} {{ dns_ttl }} {{ dns_ttl }} {{ dns_ttl }} {{ dns_ttl }} );

; Nameservers.  Each node is its own nameserver. A DNS resolver is going
; to pick one of these at random.
;
; Also delegate the _domainkey subdomain to the main domain, so
; information is fetched from a single point.
{% for node in groups.sutty_dns %}
@ IN NS ns{{ loop.index }}.{{ sutty }}.
@ IN NS ns{{ groups.sutty_dns | length() + loop.index }}.{{ sutty }}.

_domainkey IN NS ns{{ loop.index }}.{{ sutty }}.
_domainkey IN NS ns{{ groups.sutty_dns | length() + loop.index }}.{{ sutty }}.
{% endfor %}

; The glue allows to solve nameservers located on the same domain.  They
; are added on the registrar side but we put them here to not forget
; they're needed.
{% for node in groups.sutty_dns %}
ns{{ loop.index }} IN A {{ hostvars[node].ansible_host }}
ns{{ groups.sutty_dns | length() + loop.index }} IN A {{ hostvars[node].ansible_host }}
{% endfor %}

; A* Records. Here we just make the node publish its own IP addresses,
; so when they're down, the IP address goes away with them.  This way we
; don't have to monitor node status to update the DNS information
; accordingly.
@ IN A {{ ansible_host }}
* IN A {{ ansible_host }}

{% if hostvars[item].sutty_dns.email is not defined or hostvars[item].sutty_dns.email %}
; Email servers.  Since email servers can retry and find other servers,
; if a server is down, incoming email will arrive at one or the other.  If
; all nodes are up, incoming email is distributed between them.
{% for node in groups.sutty_email %}
@ IN MX 1 {{ node }}.
{% endfor %}

@ IN TXT "v=spf1 mx -all"
_dmarc IN TXT "v=DMARC1; p={{ dmarc_policy }}; rua=mailto:rua@{{ sutty }}; ruf=mailto:ruf@{{ sutty }}"
_mta-sts IN TXT "v=STSv1; id={{ ansible_managed }}"
_smtp._tls IN TXT "v=TLSRPTv1; rua=mailto:tlsrpt@{{ sutty }}"
{% endif %}

; Certificate issuing
@ IN CAA 0 issue "letsencrypt.org"
* IN CAA 0 issue "letsencrypt.org"

; Distributed Press
_dnslink IN NS api.distributed.press.

{% if hostvars[item].sutty_dns is defined %}
{% if hostvars[item].sutty_dns.extra_records is defined %}
{% for extra_record in hostvars[item].sutty_dns.extra_records %}
; {{ extra_record.comment }}
{% for record in extra_record.records %}
{{ extra_record.name }} IN {{ record.type }} {{ record.value }}
{% endfor %}
{% endfor %}
{% endif %}
{% endif %}
